﻿@config-init @feature:1040 @jiraSpecific
Feature: Initialize SpecSync for Jira config

Rule: A basic configuration can be initialized for Jira

@tc:1212
Scenario: A basic configuration is initialized for Jira TCM
	Given there is an Azure DevOps project
	When SpecSync init is executed with answers successfully:
		| question                                            | answer                | optional |
		| Jira Server base URL                                | [remote-server-url]   | false    |
		| Jira project key                                    | [remote-project-name] | false    |
		| Do you want to check connection?                    | yes                   | false    |
		| Jira user name or user email address                | [remote-user-name]    | false    |
		| API token or password for user '[remote-user-name]' | [remote-password]     | true     |
		| TCM Solution                                        | JiraTcmCustomization  | false    |
		| Is this ok?                                         | yes                   | false    |
	Then the configuration file should be updated with
		| setting                          | value                 |
		| remote/serverUrl                 | [remote-server-url]   |
		| remote/project                   | [remote-project-name] |
		| jira/tcmSolution                 | JiraTcmCustomization  |
		| jira/testCaseIssueType/name      | Test Case             |
		| jira/customStepsField/field/name | Test Case Steps       |

@tc:1213
Scenario: A basic configuration is initialized for Jira Zephyr Scale
	Given there is an Azure DevOps project
	When SpecSync init is executed with answers successfully:
		| question                                            | answer                | optional |
		| Jira Server base URL                                | [remote-server-url]   | false    |
		| Jira project key                                    | [remote-project-name] | false    |
		| Do you want to check connection?                    | yes                   | false    |
		| Jira user name or user email address                | [remote-user-name]    | false    |
		| API token or password for user '[remote-user-name]' | [remote-password]     | true     |
		| TCM Solution                                        | ZephyrScale           | false    |
		| Is this ok?                                         | yes                   | false    |
	Then the configuration file should be updated with
		| setting          | value                 |
		| remote/serverUrl | [remote-server-url]   |
		| remote/project   | [remote-project-name] |
		| jira/tcmSolution | ZephyrScale           |
