﻿@plugins @bypass-integration
Feature: SpecSync Plugins

Rule: Can perform a push/update operation with custom local test case source

@tc:244
Scenario: Updates existing test case with custom local test case source
	Given there is a remote server project
	And the synchronizer is configured with a custom plugin
	And there is a new Test Case as
		| field | value       |
		| title | Custom test |
	And there is a custom local test case "Updated custom test" linked to the Test Case
	When the local repository is synchronized with push
	Then the Test Case title should be updated to "Updated custom test"

Rule: Can match to custom TRX test results

@tc:245
@publishTestResults
@notSupported:JIRA.DataCenter.JiraTcm @notSupported:JIRA.Cloud.JiraTcm
Scenario: Publish a TRX test result with custom mather
	The scenario shows that with a plugin a custom test result matcher can be configured. 
	As an example, in this case the test result contains the capital letters of the scenario name.
	Given there is a remote server project prepared for publishing test results
	And the synchronizer is configured with a custom test result matcher plugin
	And there is an existing synchronized scenario
		"""
		@tc:[id-of-test-case]
		Scenario: Scenario With Capital Case
			When I do something
		"""
	And there is a test result file with
		| name | adapterTypeName   | test result name | outcome |
		| SWCC | executor://custom | SWCC             | Passed  |
	When the test result is published
	Then the command should not fail
	And the there should be a Test Run registered with test results
		| test case ID      | outcome |
		| [id-of-test-case] | Passed  |

Rule: Can load custom test results

@tc:246
@publishTestResults
@notSupported:JIRA.DataCenter.JiraTcm @notSupported:JIRA.Cloud.JiraTcm
Scenario: Publish a custom test result
	The scenario shows that with a plugin a custom test result loader and matcher can be configured. 
	Given there is a remote server project prepared for publishing test results
	And the synchronizer is configured with a custom test result loader plugin
	And there is an existing synchronized scenario
		"""
		@tc:[id-of-test-case]
		Scenario: Scenario With Capital Case
			When I do something
		"""
	And there is a Custom TXT test result file as
		"""
		SWCC,Passed
		"""
	When the test result is published
	Then the command should not fail
	And the there should be a Test Run registered with test results
		| test case ID      | outcome |
		| [id-of-test-case] | Passed  |
