﻿@customization @sync-tags
Feature: Tag Text Map Transformation

Provides ability to replace substrings inside tags, e.g.
* "__" => " "
* "=" => "-"

Rule: Should transform tags on push

@tc:240
Scenario: A scenario with a tag containing mapped characters is linked
	Given there is a remote server project
	And the synchronizer is configured to use tag text map transformation as
		| local | remote |
		| __    | .      |
		| =     | -      |
	And there is a scenario in the local repository
		"""
		@my__tag=value
		Scenario: Sample scenario
			When I do something
		"""
	When the local repository is synchronized with push
	Then a new Test Case "Scenario: Sample scenario" should be created in the remote server
	And the new Test Case should have the following tags: "my.tag-value"

@tc:780
@notSupported:JIRA.DataCenter.ZephyrScale @notSupported:JIRA.DataCenter.JiraTcm @notSupported:JIRA.Cloud.JiraTcm
Scenario: Remote tag contains whitespace
	Given there is a remote server project
	And the synchronizer is configured to use tag text map transformation as
		| local | remote |
		| __    | " "    |
	And there is a scenario in the local repository
		"""
		@my__tag
		Scenario: Sample scenario
			When I do something
		"""
	When the local repository is synchronized with push
	Then a new Test Case "Scenario: Sample scenario" should be created in the remote server
	And the new Test Case should have the following tags: "my tag"

Rule: Should detect scenario as unchanged with transformed tags

@tc:241
Scenario: Scenario with a transformed tag was not changed
	Given there is a remote server project
	And the synchronizer is configured to use tag text map transformation as
		| local | remote |
		| =     | -      |
	And there is an existing synchronized scenario
		"""
		@my=tag
		Scenario: Sample scenario
			When I do something
		"""
	When the local repository is synchronized with push
	Then the Test Case should not be changed

Rule: Reverse transformation is performed on pull

@tc:242
Scenario: A transformed tag is added to the test case
	Given there is a remote server project
	And the synchronizer is configured to use tag text map transformation as
		| local | remote |
		| =     | -      |
	And the synchronizer is configured to enable pull
	And there is an existing synchronized scenario
		"""
		Scenario: Sample scenario
			When I do something
		"""
	When the Test Case tags are updated to "my-tag"
	And the local repository is synchronized with pull
	Then the scenario in the local repository should be updated to:
		"""
		@tc:[id-of-test-case]
		@my=tag
		Scenario: Sample scenario
			When I do something
		"""